using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Soap;
using System.IO;


namespace XMLSer
{
	/// <summary>
	/// Gre une collection de TRectangle
	/// </summary>
	[Serializable]
	internal class TRectangleCollection : ArrayList{
	
		public TRectangleCollection() : base(){}

		public override int Add(object r){
			if (r is TRectangle)
				return base.Add(r);
			else 
				return -1;
		}
	}

	/// <summary>
	/// Stocke les proprits d'un rectangle (STRUCTURE !!)
	/// </summary>
	[Serializable]
	internal struct TRectangle {
		internal int xHautGauche;
		internal int yHautGauche ;
		internal int largeur;
		internal int hauteur;
		internal Color couleur;
	}

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnClear;
		private System.Windows.Forms.Button btnSaveAs;
		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.PictureBox pic;
		private System.Windows.Forms.ColorDialog choixCouleur;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.SaveFileDialog where;
		private System.Windows.Forms.OpenFileDialog ouvrir;

		private TRectangleCollection Rectangles = new TRectangleCollection();

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pic = new System.Windows.Forms.PictureBox();
			this.btnClear = new System.Windows.Forms.Button();
			this.btnSaveAs = new System.Windows.Forms.Button();
			this.btnLoad = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.choixCouleur = new System.Windows.Forms.ColorDialog();
			this.where = new System.Windows.Forms.SaveFileDialog();
			this.ouvrir = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// pic
			// 
			this.pic.BackColor = System.Drawing.Color.White;
			this.pic.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pic.Location = new System.Drawing.Point(8, 8);
			this.pic.Name = "pic";
			this.pic.Size = new System.Drawing.Size(360, 208);
			this.pic.TabIndex = 0;
			this.pic.TabStop = false;
			this.pic.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pic_MouseUp);
			// 
			// btnClear
			// 
			this.btnClear.Location = new System.Drawing.Point(16, 224);
			this.btnClear.Name = "btnClear";
			this.btnClear.TabIndex = 1;
			this.btnClear.Text = "&Clear";
			this.btnClear.Click += new System.EventHandler(this.button1_Click);
			// 
			// btnSaveAs
			// 
			this.btnSaveAs.Location = new System.Drawing.Point(16, 288);
			this.btnSaveAs.Name = "btnSaveAs";
			this.btnSaveAs.TabIndex = 2;
			this.btnSaveAs.Text = "&Save as ...";
			this.btnSaveAs.Click += new System.EventHandler(this.btnSaveAs_Click);
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(16, 256);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.TabIndex = 3;
			this.btnLoad.Text = "&Load ...";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(112, 224);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(256, 88);
			this.label1.TabIndex = 4;
			this.label1.Text = "Draw some rectangles in the area above, and save it to an XML file. Then, try loa" +
				"ding it to ensure that it has been correctly saved !";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// where
			// 
			this.where.Filter = "xml|*.xml|all|*.*";
			// 
			// ouvrir
			// 
			this.ouvrir.Filter = "xml|*.xml|all|*.*";
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 317);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.btnLoad,
																		  this.btnSaveAs,
																		  this.btnClear,
																		  this.pic});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "XML SOAP (De)Serialization";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void ClearPic(){
			if (pic.Image != null)
			{
				Graphics g = Graphics.FromImage (pic.Image);

				g.Clear(Color.White);

				g.DrawImage (pic.Image, 0, 0, pic.Width, pic.Height);

				g.Dispose();

				pic.Refresh();
			}
		
		}
		private void button1_Click(object sender, System.EventArgs e)
		{
			ClearPic();

			Rectangles.Clear();
		}

		private void DrawSquare (Color c, int x, int y, int w, int h){
			//Drawin n stuff
			if (pic.Image == null)
				pic.Image = new Bitmap (pic.Width, pic.Height);

			Graphics g = Graphics.FromImage (pic.Image);

			g.DrawRectangle (new Pen(c, 3), x,y,w,h);

			g.DrawImage (pic.Image, 0, 0, pic.Width, pic.Height);

			g.Dispose();

			pic.Refresh();
		
		}

		private void pic_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (choixCouleur.ShowDialog() == DialogResult.OK)
			{
				//Drawin n stuff
				DrawSquare(choixCouleur.Color, e.X, e.Y, 20, 20);

				//savin 2 da struct
				TRectangle r = new TRectangle();
				r.xHautGauche = e.X;
				r.yHautGauche = e.Y;
				r.largeur = 20;
				r.hauteur = 20;
				r.couleur = choixCouleur.Color;

				Rectangles.Add (r);
			}

		}

		private void btnSaveAs_Click(object sender, System.EventArgs e)
		{
			if (where.ShowDialog() == DialogResult.OK)
			{
				FileStream fout = null;
			
				try
				{

					SoapFormatter ser = new SoapFormatter();

					fout = new FileStream(where.FileName, FileMode.Create);
	    
					ser.Serialize(fout, Rectangles);
				}
				catch (Exception) { throw; }
				finally 
				{
					if (fout != null)
						fout.Close();
				}
			}
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			if (ouvrir.ShowDialog() == DialogResult.OK)
			{
				FileStream fout = null;
			
				try
				{

					SoapFormatter ser = new SoapFormatter();

					fout = new FileStream(ouvrir.FileName, FileMode.Open);
	    
					Rectangles = (TRectangleCollection)ser.Deserialize (fout);
				}
				catch (Exception) { throw; }
				finally 
				{
					if (fout != null)
						fout.Close();
				}

				ClearPic();

				IEnumerator iter = Rectangles.GetEnumerator();
				while (iter.MoveNext()){
					TRectangle r = (TRectangle)(iter.Current);

					DrawSquare (r.couleur, r.xHautGauche, r.yHautGauche, r.largeur, r.hauteur);
				}
			}
		
		}
	}
}
